unit DesignU;

interface

uses
  XWType, XWObj, XWCont, XwAboutWebU,
  ShellAPI,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, Buttons, Spin;

type
  TXwDesignF = class(TForm)
    Panel2: TPanel;
    NavigatorP: TPanel;
    IFirstSB: TSpeedButton;
    IPrevSB: TSpeedButton;
    INextSB: TSpeedButton;
    ILastSB: TSpeedButton;
    CloseP: TPanel;
    ExitBB: TBitBtn;
    FilesP: TPanel;
    LoadSB: TSpeedButton;
    SaveSB: TSpeedButton;
    StatusB: TStatusBar;
    Panel1: TPanel;
    XWordSB: TScrollBox;
    Panel4: TPanel;
    StaticText2: TStaticText;
    IndexAST: TStaticText;
    StaticText3: TStaticText;
    NumAST: TStaticText;
    StaticText5: TStaticText;
    PNumST: TStaticText;
    PageControl1: TPageControl;
    Splitter1: TSplitter;
    OpenD: TOpenDialog;
    SaveD: TSaveDialog;
    PropertysTS: TTabSheet;
    XpsGB: TGroupBox;
    XpsVertRB: TRadioButton;
    XpsHorizRB: TRadioButton;
    XxpsSE: TSpinEdit;
    YxpsSE: TSpinEdit;
    LxpsSE: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    XpsSetBB: TBitBtn;
    StaticText1: TStaticText;
    XCoordST: TStaticText;
    StaticText6: TStaticText;
    YCoordST: TStaticText;
    GroupBox1: TGroupBox;
    XpsRemoveBB: TBitBtn;
    InsNewBB: TBitBtn;
    TabSheet1: TTabSheet;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    AboutSB: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure INavigatorSBClick(Sender: TObject);
    procedure XpsRemoveBBClick(Sender: TObject);
    procedure XpsSetBBClick(Sender: TObject);
    procedure LoadSBClick(Sender: TObject);
    procedure SaveSBClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure InsNewBBClick(Sender: TObject);
    procedure AboutSBClick(Sender: TObject);
  private
    XPanel : TXWPanel;
    XPContainer : TXWDControlCollection; //TXWDControlCollection;

    FXWLoaded : boolean;
    FXWChanged : boolean;
    FChanging : boolean;
    FXWFileName, ExportFileName : string;
    ProgramDir : string;

    Dragging, IsDragging, Resizing : boolean;
    DrObj, FDrObj : TPanel;
    DragXWDControl : TXWordDataControl;
    DragXPStr : XPStringDataType;
    StartXY, StartPanXY : TPoint;

    procedure ContainerMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CellMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CellMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure XPanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure XPanelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OnAddNewContainer(Sender: TObject; Index : integer);
    procedure BeginDragPanel(Sender: TObject; X, Y: Integer);
    procedure BeginResizePanel(Sender: TObject; X, Y: Integer);
    procedure CreateDragPanel( Sender: TObject);
    procedure FreeDragPanel;
    procedure MoveDragPanel( X, Y : integer);
    procedure ResizeDragPanel( X, Y : integer);
    procedure DropDragPanel( Copy: boolean);

    procedure SetXWLoaded( Value : boolean);
    procedure SetXWFileName( Value : string);
    procedure SetXWChanged( Value : boolean);
    procedure SetGroupEnabled( Own : TWinControl; Enable : boolean);
    function GetCurrentXPS : XPStringDataType;
    procedure SetCurrentXPS( Value : XPStringDataType);

    procedure LoadPattern( FName : string);
    function LoadFromEncriptStream( Stream : TStream) : boolean;
    procedure SavePattern( FName : string);

    procedure XPCIndexChanged(Sender: TObject; OldIndex : integer);
    procedure WriteMouseCoords( X, Y : integer);

    procedure NewPattern;
    procedure ChangePattern( WD : TXWordDataControl;
                             NewData : XPStringDataType; Copy : boolean);
    procedure DeletePattern( WD : TXWordDataControl);
    procedure FlipPattern;

    procedure RedrawPanel;
  protected
    procedure WMDropFiles(var Msg: TMessage); message wm_DropFiles;
    property XWLoaded : boolean read FXWLoaded write SetXWLoaded;
    property XWFileName : string read FXWFileName write SetXWFileName;
    property XWChanged : boolean read FXWChanged write SetXWChanged;
    property CurrentXPS : XPStringDataType read GetCurrentXPS write SetCurrentXPS;
  public
  end;

var
  XwDesignF: TXwDesignF;

implementation
{$R *.DFM}

procedure TXwDesignF.FormCreate(Sender: TObject);
begin
  DragAcceptFiles(Handle, True);
  Dragging := false;
  Resizing := false;
  IsDragging := false;
  
  XPanel := TXWPanel.Create( XWordSB);
  with XPanel do begin
    Parent := XWordSB;
    Width := 470;
    Height := 470;
    CellSize := 20;
    OnMouseUp := XPanelMouseUp;
    OnMouseMove := XPanelMouseMove;
    end;


  XPContainer := TXWDControlCollection.Create;
  XPContainer.OnAdd := OnAddNewContainer;
  XPContainer.XWPanel := XPanel;
//  XPContainer.XWDescGrid := WDesc;
  XPContainer.OnIndexChange := XPCIndexChanged;

  ProgramDir := ExtractFilePath(ParamStr(0));
  OpenD.InitialDir := ProgramDir;
  SaveD.InitialDir := ProgramDir;

  // check if we should load a file from the command line
  if (ParamCount > 0) and FileExists(ParamStr(1)) then
    LoadPattern( ParamStr(1));
end;

procedure TXwDesignF.FormDestroy(Sender: TObject);
begin
  XPContainer.Free;
  XPanel.Free;
end;

{- Handle wm_DropFiles message }
procedure TXwDesignF.WMDropFiles(var Msg: TMessage);
var
  Filename: array[0 .. 256] of Char;
begin
  DragQueryFile(
    THandle(Msg.WParam),
    0,
    Filename,
    SizeOf(Filename));
  LoadPattern( StrPas(FileName));
  DragFinish( THandle(Msg.WParam));
end;

procedure TXwDesignF.SetGroupEnabled( Own : TWinControl; Enable : boolean);
var Cou : integer;
begin
  for Cou := 0 to Own.ControlCount - 1 do
    Own.Controls[ Cou].Enabled := Enable;
  Own.Enabled := Enable;
end;

procedure TXwDesignF.XPCIndexChanged(Sender: TObject; OldIndex : integer);
var
  IInd : integer;
  XWD : TXWordDataControl;
  Cou : integer;
  OL : TList;
  WDC : TXWordDataControl;
begin
  IInd := XPContainer.ItemIndex;
  XWD := XPContainer.Items[ IInd] as TXWordDataControl;
  if Assigned( XWD) then begin
    if NOT FChanging then begin
      IndexAST.Caption := IntToStr( IInd);
      PNumST.Caption := IntToStr( XWD.PatNum);
      NumAST.Caption := IntToStr( XWD.XrossNum);
      XCoordST.Caption := IntToStr( XWD.X);
      YCoordST.Caption := IntToStr( XWD.Y);
      end;
    CurrentXPS := XWD.XPS;
    end;

  for Cou := 0 to XPContainer.Count - 1 do begin
    WDC := XPContainer.Items[ Cou] as TXWordDataControl;
    XPContainer.XWords[ Cou] := '';
    end;
  OL := TList.Create;
  if XPContainer.XrossList( XPContainer.ItemIndex, OL) > 0 then begin
    WDC := ( XPContainer.Items[ IInd] as TXWordDataControl);
    WDC.XWord := 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx';
    for Cou := 0 to OL.Count - 1 do begin
      WDC := OL.Items[ Cou];
      WDC.XWord := 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx';
      end;
    end;
  if XPContainer.OverlayList( XPContainer.ItemIndex, OL) > 0 then begin
    WDC := ( XPContainer.Items[ IInd] as TXWordDataControl);
    WDC.XWord := 'oooooooooooooooooooooooooooooooooooooo';
    for Cou := 0 to OL.Count - 1 do begin
      WDC := OL.Items[ Cou];
      WDC.XWord := 'oooooooooooooooooooooooooooooooooooooo';
      end;
    end;
  OL.Free;

end;

procedure TXwDesignF.WriteMouseCoords( X, Y : integer);
begin
  XCoordST.Caption := IntToStr( X);
  YCoordST.Caption := IntToStr( Y);
end;

procedure TXwDesignF.ContainerMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
begin
  Dragging := true;
  SetCapture( XPanel.Handle);
  StartXY.X := X;
  StartXY.Y := Y;
  CreateDragPanel( Sender);
end;

procedure TXwDesignF.CellMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then begin
    IsDragging := true;
    StartXY.X := X; StartXY.Y := Y;
    DragXWDControl := (( Sender as TControl).Parent as TXCellContainer).XWDControl;
    DragXPStr := DragXWDControl.XPS;
    StartXY := ( Sender as TControl).Parent.ScreenToClient(
               ( Sender as TControl).ClientToScreen( StartXY));
    end else
  if Button = mbRight then begin
    FlipPattern;
    end;
end;

procedure TXwDesignF.CellMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
const Delta = 3;
begin
  if IsDragging AND ( ssLeft IN Shift) then begin
    if ( abs( StartXY.X - X) > Delta) OR  ( abs( StartXY.Y - Y) > Delta) then begin
      if ssShift IN Shift then BeginResizePanel(Sender, X, Y)
      else BeginDragPanel( Sender, X, Y);
      end;
    end
  else IsDragging := false;
end;

procedure TXwDesignF.XPanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
begin
  if Dragging then MoveDragPanel( X, Y) else
  if Resizing then ResizeDragPanel( X, Y);
end;

procedure TXwDesignF.XPanelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
begin
  if Dragging OR Resizing then DropDragPanel( ssCtrl IN Shift);
end;

procedure TXwDesignF.OnAddNewContainer(Sender: TObject; Index : integer);
var
  XCc : TXCellContainer;
  XC : TXCell;
  Cou : integer;
  OL : TList;
  WDC : TXWordDataControl;
begin
  XCc := (XPContainer.Items[ Index] as TXWordDataControl).CellContainer;
  XCc.OnMouseDown := ContainerMouseDown;
  for Cou := 0 to XCc.XCellCount - 1 do begin
    XC := XCc.XCell[ Cou];
    XC.OnMouseDown := CellMouseDown;
    XC.OnMouseMove := CellMouseMove;
    end;

//  RedrawPanel;
end;

procedure TXwDesignF.LoadPattern( FName : string);
var
  FN, FExt : string;
  Loaded : boolean;

  function LoadTextPattern( FN : string) : boolean;
  begin
    XPContainer.LoadFromTextFile( FN);
    Result := true;
  end;

  function LoadCompressPattern( FN : string) : boolean;
  begin
    Result := false;
  end;

begin
  FN := '';
  Loaded := false;
  if FName <> '' then FN := FName
  else begin
    OpenD.Title := 'Open XWord file';
    if OpenD.Execute then FN := OpenD.FileName;
    end;
  if FN <> '' then begin
    FExt := AnsiLowerCase( ExtractFileExt( FN));
    if FExt = AnsiLowerCase( extXWPattern) then
      Loaded := LoadTextPattern( FN) else
    if FExt = AnsiLowerCase( extComprXWPattern) then
      Loaded := LoadCompressPattern( FN);
    if Loaded then begin  // pattern loaded
      XWLoaded := Loaded;
      XWFileName := FN;
      XPContainer.ItemIndex := 0;
      StatusB.Panels[0].Text := ExtractFileName( XWFileName);
      end;
    end;
end;

function TXwDesignF.LoadFromEncriptStream( Stream : TStream) : boolean;
begin
end;

procedure TXwDesignF.SavePattern( FName : string);
var Cou, CIndex : integer;
begin
  try
    XPContainer.Check;
  except
    Application.MessageBox( 'Can''t save file', 'Error in collection', MB_OK);
    exit;
    end;
  with SaveD do begin
    Title := 'Save as ...';
    FileName := '*' + extXWPattern;
    if Execute then begin
      CIndex := XPContainer.ItemIndex;
      for Cou := 0 to XPContainer.Count - 1 do XPContainer.XWords[ Cou] := '';
      XPContainer.SaveToTextFile( FileName);
      XPContainer.ItemIndex := 0; XPContainer.ItemIndex := CIndex;
      end;
    end;
  XWChanged := false;
end;

procedure TXwDesignF.SetXWLoaded( Value : boolean);
begin
  FXWLoaded := Value;
  SetGroupEnabled( NavigatorP, FXWLoaded);

  SetGroupEnabled( PropertysTS, FXWLoaded);

  if FXWLoaded then begin
    FXWChanged := true; XWChanged := false;
    XPCIndexChanged( Self, -1);
    end;
end;

procedure TXwDesignF.SetXWFileName( Value : string);
begin
  FXWFileName :=  Value;
  StatusB.Panels[0].text := ExtractFileName( FXWFileName);
end;

procedure TXwDesignF.SetXWChanged( Value : boolean);
begin
end;

procedure TXwDesignF.INavigatorSBClick(Sender: TObject);
begin
  with XPContainer do
    case ( Sender as TSpeedButton).Tag of
      1 : { First} ItemIndex := 0;
      2 : { Prior} if ItemIndex > 0 then ItemIndex := ItemIndex - 1;
      3 : { Next}  if ItemIndex < Count - 1 then ItemIndex := ItemIndex + 1;
      4 : { Last}  XPContainer.ItemIndex := XPContainer.Count - 1;
      end;
end;

procedure TXwDesignF.NewPattern;
var
  XWD : TXWordDataControl;
  XCc : TXCellContainer;
  XC : TXCell;
  XPS : XPStringDataType;
  Ind, Cou : integer;
begin
  with XPS do begin
    X := 1;
    Y := 1;
    L := 5;
    O := XPSHorizontal;
    end;
  if XPContainer.Count <= 0 then XPContainer.Bounds := Point( 10, 10);

  XWD := TXWordDataControl.Create( XPS);
  Ind := XPContainer.Add( XWD);

  XCc := (XWD as TXWordDataControl).CellContainer;
  XCc.OnMouseDown := ContainerMouseDown;
  for Cou := 0 to XCc.XCellCount - 1 do begin
    XC := XCc.XCell[ Cou];
    XC.OnMouseDown := CellMouseDown;
    XC.OnMouseMove := CellMouseMove;
    end;
    
  XPContainer.Lock := false;
  XPContainer.ItemIndex := XWD.Index;
  RedrawPanel;
end;

procedure TXwDesignF.ChangePattern( WD : TXWordDataControl;
                                    NewData : XPStringDataType; Copy : boolean);
var
  XWD : TXWordDataControl;
  XPS : XPStringDataType;
begin
  FChanging := true;
  XPS := WD.XPS;
  if EqualByBytes( XPS, NewData, SizeOf(NewData)) then exit;
  XPContainer.Lock := true;
  if NOT Copy then DeletePattern( WD);
  XWD := TXWordDataControl.Create( NewData);
  XPContainer.Add( XWD);
  XPContainer.Lock := false;
  XPContainer.ItemIndex := XWD.Index;
  FChanging := false;
end;

procedure TXwDesignF.DeletePattern( WD : TXWordDataControl);
begin
  XPContainer.Remove( WD.Index);
end;

function TXwDesignF.GetCurrentXPS : XPStringDataType;
begin
  if XpsHorizRB.Checked then Result.O := XPSHorizontal
  else                       Result.O := XPSVertical;
  Result.X := XxpsSE.Value;
  Result.Y := YxpsSE.Value;
  Result.L := LxpsSE.Value;
end;

procedure TXwDesignF.SetCurrentXPS( Value : XPStringDataType);
begin
  if Value.O = XPSHorizontal then XpsHorizRB.Checked := true
  else                            XpsVertRB.Checked := true;
  XxpsSE.Value := Value.X;
  YxpsSE.Value := Value.Y;
  LxpsSE.Value := Value.L;
end;

procedure TXwDesignF.XpsRemoveBBClick(Sender: TObject);
begin
  if XPContainer.Count > 0 then
    DeletePattern( TXWordDataControl( XPContainer.Items[ XPContainer.ItemIndex]));
  RedrawPanel;
end;

procedure TXwDesignF.XpsSetBBClick(Sender: TObject);
begin
  if XPContainer.Count <= 0 then exit;
  ChangePattern( TXWordDataControl( XPContainer.Items[ XPContainer.ItemIndex]),
                 CurrentXPS, false);
end;

procedure TXwDesignF.CreateDragPanel( Sender: TObject);
begin
  StartPanXY.X := TPanel(Sender).Left;
  StartPanXY.Y := TPanel(Sender).Top;

  DrObj := TPanel.Create( TControl(Sender).Parent);
  with DrObj do begin
    Parent := TWinControl(Sender).Parent as TWinControl;
    Left := TPanel(Sender).Left{ + 4};
    Top := TPanel(Sender).Top{ + 4};
    Width := TPanel(Sender).Width - 8;
    Height := TPanel(Sender).Height - 8;
    end;

  FDrObj := TPanel.Create( TControl(Sender).Parent);
  with FDrObj do begin
    Parent := TWinControl(Sender).Parent as TWinControl;
    Left := TPanel(Sender).Left;
    Top := TPanel(Sender).Top;
    Width := TPanel(Sender).Width;
    Height := TPanel(Sender).Height;
    Color := clBtnHighLight;
    SendToBack;
    end;
end;

procedure TXwDesignF.FreeDragPanel;
begin
  DrObj.Free;
  FDrObj.Free;
end;

procedure TXwDesignF.BeginDragPanel(Sender: TObject; X, Y: Integer);
begin
  Dragging := true; IsDragging := false;
  SetCapture( XPanel.Handle);
  Screen.Cursor := crSize;
  CreateDragPanel( DragXWDControl.CellContainer);
end;

procedure TXwDesignF.BeginResizePanel(Sender: TObject; X, Y: Integer);
begin
  Resizing := true; IsDragging := false;
  SetCapture( XPanel.Handle);
  if CurrentXPS.O = XPSHorizontal then Screen.Cursor := crSizeWE
  else                                 Screen.Cursor := crSizeNS;
  CreateDragPanel( DragXWDControl.CellContainer);
end;

procedure TXwDesignF.MoveDragPanel( X, Y : integer);
var
  Granul : integer;
  dX, dY : integer;
begin
  Granul := XPanel.CellSize;
  dX := X - StartXY.X;
  dY := Y - StartXY.Y;
//  WriteMouseCoords( X, Y);

  DrObj.Left := dX;
  DrObj.Top := dY;
  FDrObj.Left := DrObj.Left - ( DrObj.Left MOD Granul) + 4;
  FDrObj.Top := DrObj.Top - ( DrObj.Top MOD Granul) + 4;

  DragXPStr.X := FDrObj.Left DIV XPanel.CellSize + 1;
  DragXPStr.Y := FDrObj.Top DIV XPanel.CellSize + 1;
  CurrentXPS := DragXPStr;
end;

procedure TXwDesignF.ResizeDragPanel( X, Y : integer);
var
  Granul : integer;
begin
  Granul := XPanel.CellSize;
  if CurrentXPS.O = XPSHorizontal then  begin
    DrObj.Width := X - StartXY.X;
    FDrObj.Width := DrObj.Width - ( DrObj.Width MOD Granul) + 4;
    DragXPStr.L := FDrObj.Width DIV XPanel.CellSize + 1;
    end
  else begin
    DrObj.Height := Y - StartXY.Y;
    FDrObj.Height := DrObj.Height - ( DrObj.Height MOD Granul) + 4;
    DragXPStr.L := FDrObj.Height DIV XPanel.CellSize + 1;
    end;
  CurrentXPS := DragXPStr;
end;

procedure TXwDesignF.DropDragPanel( Copy : boolean);
begin
  Screen.Cursor := crDefault;
  ReleaseCapture;
  FreeDragPanel;
  if Resizing then ChangePattern( DragXWDControl, CurrentXPS, false)
  else             ChangePattern( DragXWDControl, CurrentXPS, Copy);
  Dragging := false;
  Resizing := false;
end;

procedure TXwDesignF.LoadSBClick(Sender: TObject);
begin
  LoadPattern( '');
end;

procedure TXwDesignF.SaveSBClick(Sender: TObject);
begin
  SavePattern( XWFileName);
end;

procedure TXwDesignF.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_Delete : XpsRemoveBB.Click;
    VK_Insert : InsNewBB.Click;
    end;
end;

procedure TXwDesignF.RedrawPanel;
var
  XCc : TXCellContainer;
  XC : TXCell;
  Cou, CCou : integer;
begin
  for Cou := 0 to XPContainer.Count - 1 do begin
    XCc := (XPContainer.Items[ Cou] as TXWordDataControl).CellContainer;
    for CCou := 0 to XCc.XCellCount - 1 do  Xcc.XCell[ CCou].Repaint;
    XCc.Repaint;
    end;
  XPanel.Invalidate;  
end;

procedure TXwDesignF.InsNewBBClick(Sender: TObject);
begin
  NewPattern;
end;

procedure TXwDesignF.FlipPattern;

begin
  if CurrentXPS.O = XPSHorizontal then XpsVertRB.Checked := true
  else                                 XpsHorizRB.Checked := true;
  XpsSetBBClick( Self);
end;







procedure TXwDesignF.AboutSBClick(Sender: TObject);
begin
  XwAboutWebF.ShowModal;
end;

end.
