unit WebDownloadU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, agsocket, aghttp, ExtCtrls;

type
  TWebDownloadF = class(TForm)
    OkBB: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    HTTP: TagHTTP;
    Panel1: TPanel;
    StatusL: TLabel;
    Panel2: TPanel;
    FileDescLB: TListBox;
    FNameP: TPanel;
    XwHTTP: TagHTTP;
    Timer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FileDescLBClick(Sender: TObject);
    procedure HTTPOpen(Sender: TObject);
    procedure HTTPProgress(Sender: TObject; Perc, Transferred: Integer);
    procedure HTTPClosed(Sender: TObject);
    procedure OkBBClick(Sender: TObject);
    procedure HTTPError(Sender: TObject; var Msg: String);
    procedure TimerTimer(Sender: TObject);
    procedure FileDescLBDblClick(Sender: TObject);
  private
    FXwStream : TStream;
    ListLoaded : boolean;
    XwDirList, XwDirNamesList : TStringList;
    FFileName : string;


    function LoadFileList : boolean;
    function GetFileName : string;
  public
    property XwStream : Tstream read FXwStream;
    property FileName : string read FFileName;
  end;

var
  WebDownloadF: TWebDownloadF;

implementation
{$R *.DFM}
uses XwInternetU;

procedure TWebDownloadF.FormCreate(Sender: TObject);
begin
  ListLoaded := false;
  FFileName := '';
  FXwStream := TMemoryStream.Create;
  HTTP.URL := XwWebSite + XwWebXwFileList;
  XwDirList := TStringList.Create;
  XwDirNamesList := TStringList.Create;
end;

procedure TWebDownloadF.FormDestroy(Sender: TObject);
begin
  FXwStream.Free;
  XwDirList.Free;
  XwDirNamesList.Free;
end;

function TWebDownloadF.LoadFileList : boolean;
begin
  Result := GetXwFilesDirList( HTTP, XwDirList, XwDirNamesList);
  if Result then begin
    FileDescLB.Items := XwDirNamesList;
    FileDescLB.ItemIndex := 0;
    FileDescLBClick( FileDescLB);
    end
  else MessageDlg( 'File list is unavailable.'+ ^M +
                   'Try later or' + ^M +
                   'view information at: ' + XwWebSite,
                    mtError, [mbOk], 0);
end;

procedure TWebDownloadF.FormShow(Sender: TObject);
begin
  if NOT ListLoaded then Timer.Enabled := true;{ListLoaded := LoadFileList;}
end;

procedure TWebDownloadF.BitBtn3Click(Sender: TObject);
begin LoadFileList; end;

function TWebDownloadF.GetFileName : string;
begin
  Result :=
    Trim( XwDirList.Values[ FileDescLB.Items[ FileDescLB.ItemIndex]]);
end;

procedure TWebDownloadF.FileDescLBClick(Sender: TObject);
begin
  FNameP.Caption := ' ' + GetFileName;
end;

procedure TWebDownloadF.HTTPOpen(Sender: TObject);
begin
  StatusL.Caption := 'Open connection';
end;

procedure TWebDownloadF.HTTPProgress(Sender: TObject; Perc,
  Transferred: Integer);
begin
  StatusL.Caption := Format( 'Transfering data ... %d percent', [ Perc]);
end;

procedure TWebDownloadF.HTTPClosed(Sender: TObject);
begin
  StatusL.Caption := 'Connection closed';
end;

procedure TWebDownloadF.HTTPError(Sender: TObject; var Msg: String);
begin
  StatusL.Caption := 'ERROR';
end;

procedure TWebDownloadF.OkBBClick(Sender: TObject);
var
  FN : string;
begin
  FN := GetFileName;
  if FN = '' then exit;
  ( XwStream as TMemoryStream).Clear;
  if GetXwData( XwHTTP, FN, FXwStream) then begin
    ModalResult := mrOk;
    FFileName := FN;
    end
  else MessageDlg('Can''t find file ' + FN, mtError, [mbOk], 0);
end;
 
procedure TWebDownloadF.TimerTimer(Sender: TObject);
begin
  Timer.Enabled := false;
  ListLoaded := LoadFileList;
end;

procedure TWebDownloadF.FileDescLBDblClick(Sender: TObject);
begin
  OkBB.Click;
end;

end.
