unit XwFillU;

interface

uses
  XWType, XWObj, XWCont, XwContFill, HtmlExport, XwAboutWebU, XwDMU,
  ShellAPI,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Buttons, StdCtrls, ExtCtrls, DBTables, Db, Grids,
  DBGrids, Mask, DBCtrls, Spin;

const
  AppVersion = '1.0';
  
  { Stream ID and Settings length}
  sidXWordFillDesktop    = $F002; slXWordFillDesktop = 100;

type
  TWordChoose = ( wcAll, wcExplained, wcNotExplained);

type
  TXwFillF = class(TForm)
    StatusB: TStatusBar;
    OpenD: TOpenDialog;
    SaveD: TSaveDialog;
    Panel2: TPanel;
    FillP: TPanel;
    GoSB: TSpeedButton;
    StopSB: TSpeedButton;
    NavigatorP: TPanel;
    IFirstSB: TSpeedButton;
    IPrevSB: TSpeedButton;
    INextSB: TSpeedButton;
    ILastSB: TSpeedButton;
    INextCalcSB: TSpeedButton;
    PageControl1: TPageControl;
    OptionsTS: TTabSheet;
    FillGB: TGroupBox;
    FMMostCB: TCheckBox;
    FMLengthRB: TRadioButton;
    FMFillRB: TRadioButton;
    FMXrossRB: TRadioButton;
    DeleteGB: TGroupBox;
    DMMostCB: TCheckBox;
    DMLengthRB: TRadioButton;
    DMFillRB: TRadioButton;
    DMXrossRB: TRadioButton;
    DMDeleteCB: TCheckBox;
    Splitter1: TSplitter;
    Panel1: TPanel;
    XWordSB: TScrollBox;
    Panel4: TPanel;
    StaticText2: TStaticText;
    IndexAST: TStaticText;
    StaticText3: TStaticText;
    NumAST: TStaticText;
    StaticText6: TStaticText;
    WordAST: TStaticText;
    StaticText5: TStaticText;
    PNumST: TStaticText;
    StaticText9: TStaticText;
    TouchCouST: TStaticText;
    FMTouchRB: TRadioButton;
    DMTouchRB: TRadioButton;
    ExplainsTS: TTabSheet;
    WDescP: TPanel;
    CloseP: TPanel;
    ExitBB: TBitBtn;
    ExpEditP: TPanel;
    Panel7: TPanel;
    ReloadExplainBB: TBitBtn;
    DBMemo1: TDBMemo;
    DBText1: TDBText;
    FilesP: TPanel;
    LoadSB: TSpeedButton;
    SaveSB: TSpeedButton;
    ExpBbP: TPanel;
    DelWordBB: TBitBtn;
    PrepareTS: TTabSheet;
    ClearAllBB: TBitBtn;
    ExportBB: TBitBtn;
    WordChRG: TRadioGroup;
    RepetitionGB: TGroupBox;
    RepCouSE: TSpinEdit;
    Label2: TLabel;
    RepFillCB: TCheckBox;
    RepDelCB: TCheckBox;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    GroupST: TStaticText;
    RepetST: TStaticText;
    StaticText13: TStaticText;
    FMethodST: TStaticText;
    PrepToExportBB: TBitBtn;
    ExportTextBB: TBitBtn;
    HtmlExpBB: TBitBtn;
    FNameST: TStaticText;
    StaticText15: TStaticText;
    UsedCouCB: TCheckBox;
    Bevel1: TBevel;
    Bevel2: TBevel;
    UsedAddCB: TCheckBox;
    UsedCouSE: TSpinEdit;
    Label1: TLabel;
    WordChDinamCB: TCheckBox;
    StaticText14: TStaticText;
    WrdChhST: TStaticText;
    RestoreBB: TBitBtn;
    AboutSB: TSpeedButton;
    LoadDBSB: TSpeedButton;
    ClearBB: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure INavigatorSBClick(Sender: TObject);
    procedure GoSBClick(Sender: TObject);
    procedure StopSBClick(Sender: TObject);
    procedure ClearBBClick(Sender: TObject);
    procedure WordExpDblClick(Sender: TObject);
    procedure DelWordBBClick(Sender: TObject);
    procedure LoadSBClick(Sender: TObject);
    procedure SaveSBClick(Sender: TObject);
    procedure MethodChanged(Sender: TObject);
    procedure ReloadExplainBBClick(Sender: TObject);
    procedure ClearAllBBClick(Sender: TObject);
    procedure ExportBBClick(Sender: TObject);
    procedure PrepToExportBBClick(Sender: TObject);
    procedure ExportTextBBClick(Sender: TObject);
    procedure HtmlExpBBClick(Sender: TObject);
    procedure RestoreBBClick(Sender: TObject);
    procedure AboutSBClick(Sender: TObject);
    procedure LoadDBSBClick(Sender: TObject);
  private
    XPanel : TXWPanel;
    XPContainer : TXWordFillCollection; //TXWDControlCollection;
    WDesc : TXWDescGrid;
    XMatchWords : TStringList;
    FRun : boolean;
    IsRunning : boolean;
    FillHist : TFillHistoryList;
    FWordChoose : TWordChoose;

    FXWLoaded : boolean;
    FXWChanged : boolean;
    FReadyToExport : boolean;
    FXWFileName, ExportFileName : string;
    ProgramDir : string;

    procedure SetXWFileName( Value : string);
    procedure SetXWLoaded( Value : boolean);
    procedure SetXWChanged( Value : boolean);
    procedure XPCIndexChanged(Sender: TObject; OldIndex : integer);
    procedure SetRun( Value : boolean);
    procedure SetGroupEnabled( Own : TWinControl; Enable : boolean);
    procedure SetReadyToExport( Value : boolean);
    procedure SetWordChoose( Value : TWordChoose);


    procedure LoadPattern( FName : string);
    function LoadFromEncriptStream( Stream : TStream) : boolean;
    procedure SavePattern( FName : string);

    procedure SaveSettings( Stream: TStream);
    procedure LoadSettings( Stream: TStream);

    procedure CalcStatistics;
    procedure SetMethods;
    function GetStartWordChoose : TWordChoose;

    function GetNextFilledIndex : integer;
    function FindMatchWords : integer;
    procedure SetWord( CurXWF : TXWordFill; XW : string);
    procedure ClearWord( CurXWF : TXWordFill);
    procedure ClearDeletedMethod( CurXWF : TXWordFill);
    function PositionWordInDB( W : string) : boolean;
    procedure ShowKeyWord( S : string);
    function IsThereRepetitions : boolean;
    procedure ChangeFillDeleteMethods;
  protected
    property XWFileName : string read FXWFileName write SetXWFileName;
    procedure WMDropFiles(var Msg: TMessage); message wm_DropFiles;
    property XWLoaded : boolean read FXWLoaded write SetXWLoaded;
    property XWChanged : boolean read FXWChanged write SetXWChanged;
    property Run : boolean read FRun write SetRun;
    property ReadyToExport : boolean read FReadyToExport write SetReadyToExport;
    property WordChoose : TWordChoose read FWordChoose write SetWordChoose;
    procedure LoadDB( FName : string);
  public
  end;

var
  XwFillF: TXwFillF;

implementation

{$R *.DFM}

procedure TXwFillF.FormCreate(Sender: TObject);
begin
  DragAcceptFiles(Handle, True);
  Randomize;

  XPanel := TXWPanel.Create( XWordSB);
  with XPanel do begin
    Parent := XWordSB;
    Width := 470;
    Height := 470;
    CellSize := 20;
    end;

  WDesc := TXWDescGrid.Create( WDescP);
  with WDesc do begin
    Parent := WDescP;
    OnDblClick := WordExpDblClick;
    Align := alClient;
    ColWidths[ 1] := 99;
    ColWidths[ 2] := WDescP.Width - ColWidths[ 0] - ColWidths[ 1] - 21;
    end;

  XPContainer := TXWordFillCollection.Create;
  XPContainer.XWPanel := XPanel;
  XPContainer.XWDescGrid := WDesc;
  XPContainer.OnIndexChange := XPCIndexChanged;
  XMatchWords := TStringList.Create;
  FillHist := TFillHistoryList.Create;

  FRun := true; Run := false;
  FXWLoaded := true; XWLoaded := false;
  FXWChanged := true; XWChanged := false;
  FReadyToExport := true; ReadyToExport := false;

  ProgramDir := ExtractFilePath(ParamStr(0));
  OpenD.InitialDir := ProgramDir;
  SaveD.InitialDir := ProgramDir;

  PageControl1.ActivePage := OptionsTS;
  
  // check if we should load a file from the command line
  if (ParamCount > 0) and FileExists(ParamStr(1)) then
    LoadPattern( ParamStr(1));
end;

procedure TXwFillF.FormDestroy(Sender: TObject);
begin
  FillHist.Free;
  XMatchWords.Free;
  XPContainer.Free;
  XPanel.Free;
end;

{- Handle wm_DropFiles message }
procedure TXwFillF.WMDropFiles(var Msg: TMessage);
var
  Filename: array[0 .. 256] of Char;
begin
  DragQueryFile(
    THandle(Msg.WParam),
    0,
    Filename,
    SizeOf(Filename));
  LoadPattern( StrPas(FileName));
  DragFinish( THandle(Msg.WParam));
end;

procedure TXwFillF.XPCIndexChanged(Sender: TObject; OldIndex : integer);
var
  IInd : integer;
  XWF : TXWordFill;
  XW : XWordType;
  IndN, RangeS, RangeN: string;
begin
  IInd := XPContainer.ItemIndex;
  XWF := XPContainer.Items[ IInd] as TXWordFill;
  XW := XWF.XWord;
  //
  IndexAST.Caption := IntToStr( IInd);
  PNumST.Caption := IntToStr( XWF.PatNum);
  NumAST.Caption := IntToStr( XWF.XrossNum);
  TouchCouST.Caption := IntToStr( XWF.TouchCount);
  WordAST.Caption := '(' + IntToStr( length(XW)) + ') ' + XW;

  GetIndRange( XPContainer.XWords[ XPContainer.ItemIndex], IndN, RangeS, RangeN);
  //

  if NOT Run then
    try
      if XwDM.XwDBFileName <> '' then PositionWordInDB( XW);
    except end;  

end;

procedure TXwFillF.SetXWFileName( Value : string);
begin
 FXWFileName :=  Value;
 StatusB.Panels[0].text := ExtractFileName( FXWFileName);
end;


procedure TXwFillF.LoadPattern( FName : string);
var
  FN, FExt : string;
  Loaded : boolean;

  function LoadTextPattern( FN : string) : boolean;
  begin
    XPContainer.LoadFromTextFile( FN);
    Result := true;
  end;

  function LoadCompressPattern( FN : string) : boolean;
  begin
    Result := true;
  end;

  function LoadDesktop( FN : string) : boolean;
  var
    Stre : TFileStream;
  begin
    Stre := TFileStream.Create( FN, fmOpenRead);
    Result := LoadFromEncriptStream( Stre);
    Stre.Free;
  end;

begin
  FN := '';
  Loaded := false;
  if FName <> '' then FN := FName
  else begin
    OpenD.Title := 'Open XWord file';
    OpenD.Filter := 'Text|*.xwt|Encripted|*.xwc|Filled|*xwf|all|*.xwt; *.xwc; *xwf';
    if OpenD.Execute then FN := OpenD.FileName;
    end;
  if FN <> '' then begin
    FExt := AnsiLowerCase( ExtractFileExt( FN));
    if FExt = AnsiLowerCase( extXWPattern) then
      Loaded := LoadTextPattern( FN) else
    if FExt = AnsiLowerCase( extComprXWPattern) then
      Loaded := LoadCompressPattern( FN) else
    if FExt = AnsiLowerCase( extXWDesktop) then
      Loaded := LoadDesktop( FN) else
    if FExt = AnsiLowerCase( extXWFill) then
      Loaded := LoadDesktop( FN);
    if Loaded then begin  // pattern loaded
      try
        XPContainer.Check;
        XWLoaded := Loaded AND ( XwDM.XwDBFileName <> '');
        XWFileName := FN;
        XPContainer.ItemIndex := 0;
        StatusB.Panels[0].text := ExtractFileName( FXWFileName);
        FillHist.Clear; IsThereRepetitions;
      except
        XWLoaded := false;
        raise;
        end;
      end;
    end;
  ReadyToExport := false;
end;

function TXwFillF.LoadFromEncriptStream( Stream : TStream) : boolean;
var
  EStre : TWxEncriptionStream;
  LoadCou : integer;

  procedure SkipIfNeed;
  var
    SLenCou, SSign : integer;
  begin
    EStre.ReadBuffer( SSign, SizeOf( SSign));
    EStre.ReadBuffer( SLenCou, SizeOf( SLenCou));
    if ( SSign = sidXWPanel) OR
       ( SSign = sidXWordFillDesktop)  then
      EStre.Position := EStre.Position - 2 * SizeOf( SSign)
    else
      EStre.Position := EStre.Position + SLenCou;
  end;

begin
  EStre := TWxEncriptionStream.Create;
  EStre.CopyFrom( Stream, Stream.Size);

  EStre.Decript;
  EStre.Position := 0;

  LoadCou := 0;
  try
    while ( EStre.Position <= EStre.Size - 1) AND ( LoadCou < 10) do begin
      SkipIfNeed;
      LoadSettings( EStre);
      XPanel.LoadSettings( EStre);
      XPContainer.LoadFromStream( EStre);
      inc( LoadCou);
      end;
    Result := LoadCou < 10;
  except Result := false; end;

  EStre.Free;
end;

procedure TXwFillF.SavePattern( FName : string);
  procedure SaveDesktop( FName : string);
  var
    Stre : TFileStream;
    EStre : TWxEncriptionStream;
    FP : integer;
    FE : string;
  begin
    FE := ExtractFileExt( FName);
    FP := System.Pos( FE, FName);
    System.Delete( FName, FP, length( FE));
    FName := FName + extXWFill;
    Stre := TFileStream.Create( FName, fmCreate);
    EStre := TWxEncriptionStream.Create;

    SaveSettings( EStre);
    XPanel.SaveSettings( EStre);
//      WEdit.SaveSettings( EStre);
    WDesc.SaveSettings( EStre);
    XPContainer.SaveToStream( EStre); // pattern data

    EStre.Encript;
    EStre.Position := 0;
    Stre.CopyFrom( EStre, EStre.Size);

    Stre.Free;
    EStre.Free;
  end;

begin
  if FName <> '' then begin
    SaveD.Title := 'Save';
    SaveDesktop( FName);
    end
  else
    with SaveD do begin
      Title := 'Save as ...';
      FileName := '*' + extXWDesktop;
      if Execute then begin
        SaveDesktop( FileName);
        end;
      end;
  XWChanged := false;
end;

procedure TXwFillF.SaveSettings( Stream: TStream);
var
  LenCou, TmpInt : integer;
  Buf : array[1..slXWordFillDesktop] of byte;
begin
  LenCou := 0;

  //Signature and length
  TmpInt := sidXWordFillDesktop;
  Stream.WriteBuffer( TmpInt, SizeOf( TmpInt));
  TmpInt := slXWordFillDesktop;
  Stream.WriteBuffer( TmpInt, SizeOf( TmpInt));

  TmpInt := ord( XPContainer.FillMode);
  Stream.WriteBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));
  TmpInt := integer( XPContainer.FillModeMost);
  Stream.WriteBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));

  TmpInt := ord( XPContainer.DeleteMode);
  Stream.WriteBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));
  TmpInt := integer( XPContainer.DeleteModeMost);
  Stream.WriteBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));
  TmpInt := integer( DMDeleteCB.Checked);
  Stream.WriteBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));

  FillChar( Buf, slXWordFillDesktop, #0);
  Stream.WriteBuffer( Buf, slXWordFillDesktop - LenCou);
end;

procedure TXwFillF.LoadSettings( Stream: TStream);
var
  LenCou, TmpInt : integer;
  Buf : array[1..slXWordFillDesktop] of byte;
  FO : TFillOperationMode;
begin
  LenCou := 0;

  // Read signature and process
  Stream.ReadBuffer( TmpInt, SizeOf( TmpInt));
  if TmpInt <> sidXWordFillDesktop then begin
    Stream.Position := Stream.Position - SizeOf( TmpInt);
    exit;
    end;
  // Read data length ( not used)
  Stream.ReadBuffer( TmpInt, SizeOf( TmpInt));

  Stream.ReadBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));
  FO := TFillOperationMode( TmpInt);
  case FO of
    fmLength : FMLengthRB.Checked := true;
    fmFilled : FMFillRB.Checked := true;
    fmXrossed : FMXrossRB.Checked := true;
    fmTouched : FMTouchRB.Checked := true;
    end;
  Stream.ReadBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));
  FMMostCB.Checked := boolean( TmpInt);

  Stream.ReadBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));
  FO := TFillOperationMode( TmpInt);
  case FO of
    fmLength : DMLengthRB.Checked := true;
    fmFilled : DMFillRB.Checked := true;
    fmXrossed : DMXrossRB.Checked := true;
    fmTouched : DMTouchRB.Checked := true;
    end;
  Stream.ReadBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));
  DMMostCB.Checked := boolean( TmpInt);
  Stream.ReadBuffer( TmpInt, SizeOf( TmpInt)); inc( LenCou, SizeOf( TmpInt));
  DMDeleteCB.Checked := boolean( TmpInt);

  Stream.ReadBuffer( Buf, slXWordFillDesktop - LenCou);
end;

procedure TXwFillF.SetXWLoaded( Value : boolean);
begin
  FXWLoaded := Value;
  SetGroupEnabled( FillP, FXWLoaded);
  SetGroupEnabled( NavigatorP, FXWLoaded);

  SetGroupEnabled( OptionsTS, FXWLoaded);
  SetGroupEnabled( ExplainsTS, FXWLoaded);
  SetGroupEnabled( PrepareTS, FXWLoaded);

  if FXWLoaded then begin
    FXWChanged := true; XWChanged := false;
    CalcStatistics;
    end;
end;

procedure TXwFillF.LoadDB( FName : string);
var FN : string;
begin
  FN := '';
  if FName <> '' then FN := FName
  else begin
    OpenD.Title := 'Open XWord database';
    OpenD.Filter := 'XWord database|*.DB|All files|*.*';
    if OpenD.Execute then FN := OpenD.FileName;
    end;
  if FN <> '' then begin
    try
      XwDM.XwDBFileName := FN;
      StatusB.Panels[1].Text := ExtractFileName( FN);
    except
      StatusB.Panels[1].Text := '';
      raise;
      end;
    end;
  XWLoaded := ( XWFileName <> '') AND ( XwDM.XwDBFileName <> '');
end;

procedure TXwFillF.LoadSBClick(Sender: TObject);
begin LoadPattern( ''); end;

procedure TXwFillF.SaveSBClick(Sender: TObject);
begin SavePattern( XWFileName); end;

procedure TXwFillF.SetXWChanged( Value : boolean);
begin
  if FXWChanged = Value then exit;
  FXWChanged := Value;
end;

procedure TXwFillF.SetGroupEnabled( Own : TWinControl; Enable : boolean);
var Cou : integer;
begin
  for Cou := 0 to Own.ControlCount - 1 do
    Own.Controls[ Cou].Enabled := Enable;
  Own.Enabled := Enable;
end;

procedure TXwFillF.SetReadyToExport( Value : boolean);
begin
  FReadyToExport := Value;
  ExportBB.Enabled := FReadyToExport;
  ExportTextBB.Enabled := FReadyToExport;
  HtmlExpBB.Enabled := FReadyToExport;
end;

procedure TXwFillF.SetWordChoose( Value : TWordChoose);
begin
  FWordChoose := Value;
  case FWordChoose of
    wcAll : WrdChhST.Caption := 'A';
    wcExplained : WrdChhST.Caption := 'E';
    wcNotExplained : WrdChhST.Caption := 'N';
    end;
end;

procedure TXwFillF.SetRun( Value : boolean);
begin
  if FRun = Value then exit;
  FRun := Value;

  GoSB.Enabled := NOT Value;
  StopSB.Enabled := Value;
  XWordSB.Enabled := NOT Value;

  SetGroupEnabled( NavigatorP, NOT FRun);
  SetGroupEnabled( FilesP, NOT FRun);
  SetGroupEnabled( CloseP, NOT FRun);

  // Tab sheets
  SetGroupEnabled( OptionsTS, NOT FRun);
  SetGroupEnabled( ExplainsTS, NOT FRun);
  SetGroupEnabled( PrepareTS, NOT FRun);

  ReadyToExport := FReadyToExport;

  if Value then begin
    SetMethods;
    end
  else begin
    if XwDM.XwT.Active then begin
      try
        XwDM.XwT.IndexName := '';
        XwDM.XwT.CancelRange;
      except end;
      end;
    end;
end;

procedure TXwFillF.CalcStatistics;
var
  WComplete, WPartialFill, WEmpty, WTotal : integer;
begin
  WTotal := XPContainer.Count;
  XPContainer.XWStat( WComplete, WPartialFill, WEmpty);

  StatusB.Panels[2].Text :=
    'Filled ' + IntToStr( WComplete) + ' of ' + IntToStr( WTotal);
end;

procedure TXwFillF.SetMethods;
begin
  if FMLengthRB.Checked then XPContainer.FillMode := fmLength else
  if FMFillRB.Checked   then XPContainer.FillMode := fmFilled else
  if FMXrossRB.Checked  then XPContainer.FillMode := fmXrossed else
  if FMTouchRB.Checked  then XPContainer.FillMode := fmTouched else
                             XPContainer.FillMode := fmNone;
  XPContainer.FillModeMost := FMMostCB.Checked;

  if DMLengthRB.Checked then XPContainer.DeleteMode := fmLength else
  if DMFillRB.Checked   then XPContainer.DeleteMode := fmFilled else
  if DMXrossRB.Checked  then XPContainer.DeleteMode := fmXrossed else
  if DMTouchRB.Checked  then XPContainer.DeleteMode := fmTouched else
                             XPContainer.DeleteMode := fmNone;
  XPContainer.DeleteModeMost := DMMostCB.Checked;

  WordChoose := GetStartWordChoose;
  FMethodST.Caption := OperationModeNames[ XPContainer.FillMode];
end;

function TXwFillF.GetStartWordChoose : TWordChoose;
begin
  case WordChRG.ItemIndex of
    0 : Result := wcAll;
    1 : Result := wcExplained;
    2 : Result := wcNotExplained;
    else Result := wcAll;
    end;
end;

procedure TXwFillF.INavigatorSBClick(Sender: TObject);
begin
  with XPContainer do
    case ( Sender as TSpeedButton).Tag of
      1 : { First} ItemIndex := 0;
      2 : { Prior} if ItemIndex > 0 then ItemIndex := ItemIndex - 1;
      3 : { Next}  if ItemIndex < Count - 1 then ItemIndex := ItemIndex + 1;
      4 : { Last}  XPContainer.ItemIndex := XPContainer.Count - 1;
      5 : { Next calc} ItemIndex := GetNextFilledIndex;
      end;
end;

procedure TXwFillF.GoSBClick(Sender: TObject);
var
  NextFilledNdx, DeletedWordNdx, MatchWordNum : integer;
  TryCount : integer;
  XWF : TXWordFill;
  StartFillMode, StartDeleteMode : TFillOperationMode;
  StartFillModeMost, StartDeleteModeMost : boolean;

  function ChooseFindedword : string;
  var Ndx : integer;
  begin
    Result := '';
    if XMatchWords.Count <= 0 then exit;
    Ndx := Random( XMatchWords.Count);
    Result := XMatchWords.Strings[ Ndx];
  end;

begin
  Run := true;
  IsRunning := true;
  // Set fill and delete methods
  SetMethods;
  with XPContainer do begin
    StartFillMode := FillMode;     StartFillModeMost := FillModeMost;
    StartDeleteMode := DeleteMode; StartDeleteModeMost := DeleteModeMost;
    end;

  NextFilledNdx := XPContainer.GetNextFilledIndex;
  while ( NextFilledNdx >= 0) AND ( IsRunning) do begin
    Application.ProcessMessages;
    CalcStatistics;
    XPContainer.ItemIndex := NextFilledNdx;
    XWF := TXWordFill( XPContainer.Items[ NextFilledNdx]);
    MatchWordNum := FindMatchWords;
    WordChoose := GetStartWordChoose; // reset word choose method
    if MatchWordNum > 0 then begin
      XWF.XWord := ChooseFindedword;
      XWF.TouchCount := XWF.TouchCount + 1;
      FillHist.Push( XWF);
      if IsThereRepetitions then ChangeFillDeleteMethods;
      NextFilledNdx := XPContainer.GetNextFilledIndex;
      end
    else begin // can't find match word
      DeletedWordNdx := XPContainer.DeletedWordIndex( XPContainer.ItemIndex);
      if DeletedWordNdx >= 0 then
          ClearWord( TXWordFill( XPContainer.Items[ DeletedWordNdx]))
      else begin // there is no word to delete
        case WordChoose of
          wcAll          : IsRunning := false;
          wcExplained    :
            if WordChDinamCB.Checked then WordChoose := wcAll
            else                          IsRunning := false;
          wcNotExplained :
            if WordChDinamCB.Checked then WordChoose := wcAll
            else                          IsRunning := false;
          end; { case WordChoose of}
        end;
      end;
    end;
  Run := false;
end;

procedure TXwFillF.StopSBClick(Sender: TObject);
begin
  IsRunning := false;
//  Run := false;
end;

function TXwFillF.FindMatchWords : integer;
var
  IndN, RangeS, RangeN: string;
  IndOK, WordOK : boolean;
  W : string;
  DBRecCou, Cou : integer;

  procedure PrepareExit;
  begin
    XwDM.XwT.EnableControls;
    XwDM.XwT.CancelRange;
    XwDM.XwT.IndexName := '';
  end;

begin
  Result := 0;
  XwDM.XwT.DisableControls;
  XMatchWords.Clear;
  W := XPContainer.XWords[ XPContainer.ItemIndex];
  GetIndRange( W, IndN, RangeS, RangeN);
  IndOk := true;
  try
    XwDM.XwT.IndexName := IndN;
  except
    IndOk := false;
    try XwDM.XwT.IndexName := 'iXW1';
    except
      PrepareExit;
      exit;
      end;
    end;
  if NOT IndOk then begin
    GetIndRange( StringOfChar( XWWilcardChar, length( W)), IndN, RangeS, RangeN);
    end;
  Application.ProcessMessages;
  XwDM.XwT.SetRange([ RangeS], [ RangeN]);
  DBRecCou := XwDM.XwT.RecordCount;

  // Load list
  DBRecCou := 0;
  XwDM.XwT.First;
  while NOT XwDM.XwT.EOF do begin
    Application.ProcessMessages;
    if ( XWEquByWilcards( XwDM.XwTXWord.Value, W)) AND
       ( XPContainer.XWordIndex( XwDM.XwTXWord.Value) < 0) then begin
      WordOK := false;
      case WordChoose of
        wcAll          : WordOk := true;
        wcExplained    : WordOk := NOT XwDM.XwTXWExplane.IsNull;
        wcNotExplained : WordOk := XwDM.XwTXWExplane.IsNull;
        end;
      if UsedAddCB.Checked then
        WordOk := WordOk AND ( XwDM.XwTXWUsed.Value < UsedCouSE.Value);
      if WordOk then XMatchWords.Add( XwDM.XwTXWord.Value);
      end; { XWEquByWilcards( XwTXWord.Value, W) AND ...}
    XwDM.XwT.Next; inc( DBRecCou);
    end;
  PrepareExit;
  Result := XMatchWords.Count;
end;

function TXwFillF.GetNextFilledIndex : integer;
var NextNdx : integer;
begin
  Result := XPContainer.ItemIndex;
  NextNdx := XPContainer.GetNextFilledIndex;
  if NextNdx > 0 then Result := NextNdx;
end;

procedure TXwFillF.SetWord( CurXWF : TXWordFill; XW : string);
var
  W : string;
begin
  W := CurXWF.XWord;
  if XW <> '' then begin
    CurXWF.XWord := XW;
    end;
end;

procedure TXwFillF.ClearWord( CurXWF : TXWordFill);
var
  W, M, F : string;
  Cou : integer;
begin
  W := ClearXPWord( CurXWF.L);
  M := CurXWF.EditMask;
  F := FormatMaskText( M, W);
  for Cou := 1 to CurXWF.L do if F[ Cou] = ' ' then F[Cou] := XWWilcardChar;
  SetWord( CurXWF, F);
end;

procedure TXwFillF.ClearDeletedMethod( CurXWF : TXWordFill);
var
  DelNdx, CurNdx : integer;
  DelXWF : TXWordFill;
begin
  CurNdx := CurXWF.Index;
  DelNdx := XPContainer.DeletedWordIndex( CurNdx);
  if DelNdx >= 0 then ClearWord( TXWordFill( XPContainer.Items[ DelNdx]));
end;

procedure TXwFillF.ClearBBClick(Sender: TObject);
begin
  ClearWord( TXWordFill( XPContainer.Items[ XPContainer.ItemIndex]));
end;

procedure TXwFillF.WordExpDblClick(Sender: TObject);
var
  IInd : integer;
  XWF : TXWordFill;
  XW : XWordType;
begin
  IInd := XPContainer.ItemIndex;
  XWF := XPContainer.Items[ IInd] as TXWordFill;
  XW := XWF.XWord;
  ShowKeyWord( XW);
end;

function TXwFillF.PositionWordInDB( W : string) : boolean;
begin
  Result := false;
  if XwDM.XwT.FindKey( [W]) then Result := true;
  SetGroupEnabled( ExpEditP, Result);
end;

procedure TXwFillF.ShowKeyWord( S : string);
var
  HS, Top : string;
begin
  HS := 'D:\Program Files\Borland\Delphi 3\HELP\Delphi3.hlp';
  Top := S;
  WinHelp( Handle, pChar( HS), {HELP_KEY}HELP_PARTIALKEY, integer( pChar(Top)));
end;

procedure TXwFillF.DelWordBBClick(Sender: TObject);
var W : string;
begin
  W := XPContainer.XWords[ XPContainer.ItemIndex];
  ClearWord( TXWordFill( XPContainer.Items[ XPContainer.ItemIndex]));
  if XwDM.XwT.FindKey([W]) then XwDM.XwT.Delete;
end;

procedure TXwFillF.MethodChanged(Sender: TObject);
begin SetMethods; end;

procedure TXwFillF.ReloadExplainBBClick(Sender: TObject);
var
  Cou : integer;
  WF : TXWordFill;
  XW : string;
begin
  ReadyToExport := false;
  for Cou := 0 to XPContainer.Count-1 do begin
    WF := TXWordFill( XPContainer.Items[ Cou]);
    if WF.WordFill >= 100 then begin
      XW := WF.XWord;
      ReadyToExport := true;
      if XwDM.XwT.FindKey( [ XW]) then begin
        WF.XEtalon := XW;
        WF.XWDescription := XwDM.XwTXWExplane.AsString;
        if WF.XWDescription = '' then ReadyToExport := false;
        end
      else ReadyToExport := false;
      end;
    end;
end;

procedure TXwFillF.ClearAllBBClick(Sender: TObject);
var
  Cou : integer;
  WF : TXWordFill;
begin
  for Cou := 0 to XPContainer.Count-1 do begin
    WF := TXWordFill( XPContainer.Items[ Cou]);
    ClearWord( WF);
    WF.TouchCount := 0;
    WF.XWDescription := '';
    end;
end;

function TXwFillF.IsThereRepetitions : boolean;
var GNum, RCou : integer;
begin
  FillHist.IsRepetitions( GNum, RCou);
  Result := RCou >= RepCouSE.Value;
  if RCou > 0 then begin
    GroupST.Caption := IntToStr( GNum);
    RepetST.Caption := IntToStr( RCou);
    end
  else begin
    end;
end;

procedure TXwFillF.ChangeFillDeleteMethods;
var S : string;
  function NextMode( CurMode : TFillOperationMode) : TFillOperationMode;
  begin
    if CurMode = fmTouched then Result := fmLength
    else                        Result := succ( CurMode);
  end;
begin
  if NOT( RepFillCB.Checked OR RepDelCB.Checked) then exit;
  if RepFillCB.Checked then begin
    XPContainer.FillMode := NextMode( XPContainer.FillMode);
    if XPContainer.FillMode = fmLength then // change Most flag
      XPContainer.FillModeMost := NOT XPContainer.FillModeMost;
    end;
  if XPContainer.FillModeMost then S := '>'
  else                             S := '<';
  FMethodST.Caption := S + OperationModeNames[ XPContainer.FillMode];
end;

procedure TXwFillF.PrepToExportBBClick(Sender: TObject);
var
  Cou : integer;
  WF : TXWordFill;
  XW : string;
  FP : integer;
  FE, FName : string;
begin
  ReadyToExport := false;
  ExportFileName := '';
  XPContainer.Sort := skYXO;

  for Cou := 0 to XPContainer.Count-1 do begin
    WF := TXWordFill( XPContainer.Items[ Cou]);
    if WF.WordFill < 100 then begin
      Application.MessageBox( 'All patterns must be filled', 'Can''t prepare', 0);
      exit;
      end;
    if XwDM.XwT.FindKey( [ WF.XWord]) then begin
      if Trim( XwDM.XwTXWExplane.AsString) = '' then begin
        Application.MessageBox( 'Word without description', 'Can''t prepare', 0);
        exit;
        end;
      end
    else begin
      Application.MessageBox( 'Can''t find word in DB', 'Can''t prepare', 0);
      exit;
      end;
    end;

  { Get file name}
  with SaveD do begin
    Title := 'Export File Name';
    FileName :=
     '*' + extXWPattern + ';' +
     '*' + extComprXWPattern + ';' +
     '*' + extXWDesktop + ';' +
     '*' + extXWFill + ';' +
     '*' + '.html';
    if NOT Execute then begin ReadyToExport := false; exit; end;

    FName := FileName;
    FE := ExtractFileExt( FName);
    FP := System.Pos( FE, FName);
    System.Delete( FName, FP, length( FE));

    ExportFileName := FName;
    FNameST.Caption := ExtractFileName( ExportFileName);
    end;

  { Prepare crossword}
  for Cou := 0 to XPContainer.Count-1 do begin
    WF := TXWordFill( XPContainer.Items[ Cou]);
    if WF.WordFill >= 100 then begin
      XW := WF.XWord;
      WF.XWord := '*';
      ReadyToExport := true;
      if XwDM.XwT.FindKey( [ XW]) then begin
        WF.XEtalon := XW;
        WF.XWDescription := XwDM.XwTXWExplane.AsString;
        if UsedCouCB.Checked then begin
          XwDM.XwT.Edit;
          XwDM.XwTXWUsed.Value := XwDM.XwTXWUsed.Value + 1;
          try XwDM.XwT.Post;
          except XwDM.XwT.Cancel; end;
          end;
        if WF.XWDescription = '' then ReadyToExport := false;
        end
      else ReadyToExport := false;
      end;
    end;

  if NOT ReadyToExport then exit;
end;

procedure TXwFillF.ExportBBClick(Sender: TObject);
var
  Stre : TFileStream;
  EStre : TWxEncriptionStream;
  FP : integer;
  FE, FName : string;
begin
  if NOT ReadyToExport then exit;
  FName := ExportFileName + extComprXWPattern;
  Stre := TFileStream.Create( FName, fmCreate);
  EStre := TWxEncriptionStream.Create;
  XPContainer.SaveToStream( EStre); // pattern data
  EStre.Encript;
  EStre.Position := 0;
  Stre.CopyFrom( EStre, EStre.Size);
  Stre.Free;
  EStre.Free;
end;

procedure TXwFillF.ExportTextBBClick(Sender: TObject);
begin
  if NOT ReadyToExport then exit;
  XPContainer.SaveToTextFile( ExportFileName + extXWPattern);
end;

procedure TXwFillF.HtmlExpBBClick(Sender: TObject);
begin
  if NOT ReadyToExport then exit;
  ExportHTML( XPContainer, ExportFileName + '.html');
end;

procedure TXwFillF.RestoreBBClick(Sender: TObject);
var
  Cou : integer;
  WF : TXWordFill;
  XW : string;
  FP : integer;
begin
  XPContainer.Sort := skYXO;
  for Cou := 0 to XPContainer.Count-1 do begin
    WF := TXWordFill( XPContainer.Items[ Cou]);
    WF.XWord := WF.XEtalon;
    end;
end;

procedure TXwFillF.AboutSBClick(Sender: TObject);
begin
  XwAboutWebF.ShowModal;
end;

procedure TXwFillF.LoadDBSBClick(Sender: TObject);
begin
  LoadDB( '');
end;

end.
