unit XwOptPanelU;

interface

uses
  XWType, XWObj, XWCont,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, ExtCtrls;

type
  TXwOptPanelF = class(TForm)
    XWordSB: TScrollBox;
    CSizeSE: TSpinEdit;
    FontGB: TGroupBox;
    FontNameCB: TComboBox;
    FontSizeSE: TSpinEdit;
    OkBB: TBitBtn;
    CanBB: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    FontBoldCB: TCheckBox;
    WEditP: TPanel;
    Bevel1: TBevel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    EdFontNameCB: TComboBox;
    EdFontSizeSE: TSpinEdit;
    EdFontBoldCB: TCheckBox;
    Bevel2: TBevel;
    WDescP: TPanel;
    Bevel3: TBevel;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    DeFontNameCB: TComboBox;
    DeFontSizeSE: TSpinEdit;
    DeFontBoldCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CSizeSEChange(Sender: TObject);
    procedure FontNaeCBChange(Sender: TObject);
    procedure FontSizeSEChange(Sender: TObject);
    procedure FontBoldCBClick(Sender: TObject);
    procedure EdFontNmeCBChange(Sender: TObject);
    procedure EdFontSizeSEChange(Sender: TObject);
    procedure EdFontBoldCBClick(Sender: TObject);
    procedure DeFontNameCBChange(Sender: TObject);
    procedure DeFontSizeSEChange(Sender: TObject);
    procedure DeFontBoldCBClick(Sender: TObject);
  private
    FXPanel : TXWPanel;
    FWEdit : TXWordEdit;
    FWDesc : TXWDescGrid;
    XPContainer : TXWDControlCollection;

    procedure LoadXWord;
  public
    procedure SetSettings( XP : TXWPanel;
                           XE : TXWordEdit;
                           XD : TXWDescGrid);
    procedure AssignSettings( var XP : TXWPanel;
                              var XE : TXWordEdit;
                              var XD : TXWDescGrid);
  end;

var
  XwOptPanelF: TXwOptPanelF;

implementation

{$R *.DFM}

procedure TXwOptPanelF.FormCreate(Sender: TObject);
begin
  FXPanel := TXWPanel.Create( XWordSB);
  with FXPanel do begin
    Parent := XWordSB;
    Width := 470;
    Height := 470;
    CellSize := 20;
    end;
    
  FWEdit := TXWordEdit.Create( WEditP);
  with FWEdit do begin
    Parent := WEditP;
    Top := 2;
    Left := 2;
    Font.Name := 'Courier New';
    Font.Size := 12;
    Width := WEditP.Width - 4;
    end;

  FWDesc := TXWDescGrid.Create( WDescP);
  with FWDesc do begin
    Parent := WDescP;
//    Height := 200;
//    Align := alNone;
    Align := alClient;
    ColWidths[ 1] := 70;
    ColWidths[ 2] := WDescP.Width - ColWidths[ 0] - ColWidths[ 1] - 10;
    end;

  XPContainer := TXWDControlCollection.Create;
  LoadXWord;
  with XPContainer do begin
    XPContainer.XWPanel := FXPanel;
    XPContainer.XWordEdit := FWEdit;
    XPContainer.XWDescGrid := FWDesc;
    ItemIndex := 0;
    end;

  FontNameCB.Items := Screen.Fonts;
  EdFontNameCB.Items := Screen.Fonts;
  DeFontNameCB.Items := Screen.Fonts;
end;

procedure TXwOptPanelF.FormDestroy(Sender: TObject);
begin
  XPContainer.Free;
  FWDesc.Free;
  FWEdit.Free;
  FXPanel.Free;
end;

procedure TXwOptPanelF.SetSettings( XP : TXWPanel;
                                    XE : TXWordEdit;
                                    XD : TXWDescGrid);
begin
  with FXPanel do begin
    Font := XP.Font;
    CellSize := XP.CellSize;
    Color := XP.Color;
    end;
  with FWEdit do begin
    Font := XE.Font;
    end;
  with FWDesc do begin
    Font := XD.Font;
    end;
end;

procedure TXwOptPanelF.AssignSettings( var XP : TXWPanel;
                                       var XE : TXWordEdit;
                                       var XD : TXWDescGrid);
begin
  with FXPanel do begin
    XP.Font := Font;
    XP.CellSize := CellSize;
    XP.Color := Color;
    end;
  with FWEdit do begin
    XE.Font := Font;
    end;
  with FWDesc do begin
    XD.Font := Font;
    end;
end;

procedure TXwOptPanelF.FormShow(Sender: TObject);
begin
  CSizeSE.Value := FXPanel.CellSize;
  FontNameCB.ItemIndex := FontNameCB.Items.IndexOf( FXPanel.Font.Name);
  FontSizeSE.Value := FXPanel.Font.Size;
  FontBoldCB.Checked := fsBold IN FXPanel.Font.Style;

  EdFontNameCB.ItemIndex := EdFontNameCB.Items.IndexOf( FWEdit.Font.Name);
  EdFontSizeSE.Value := FWEdit.Font.Size;
  EdFontBoldCB.Checked := fsBold IN FWEdit.Font.Style;

  DeFontNameCB.ItemIndex := DeFontNameCB.Items.IndexOf( FWDesc.Font.Name);
  DeFontSizeSE.Value := FWDesc.Font.Size;
  DeFontBoldCB.Checked := fsBold IN FWDesc.Font.Style;
end;


procedure TXwOptPanelF.LoadXWord;
  procedure AddItem( W : string);
  var
    PD : TXPatternData;
    XPS : XPStringDataType;
  begin
    if W = '' then exit;
    FillChar( XPS, SizeOf( XPS), #0);
    PD := TXWordDataControl.Create( XPS);
    PD.AsString := W;
    XPContainer.Add( PD);
  end;
begin
  AddItem( 'v 2 1 6 delphi');
  AddItem( 'v 4 1 4 mike');
  AddItem( 'v 6 1 5 ');
  AddItem( 'h 1 2 8 *E*I****');
  AddItem( 'h 1 4 4 *P*E');
  XPContainer.XWords[0] := 'Delphi';
  XPContainer.XWords[1] := 'Mike';
end;

procedure TXwOptPanelF.CSizeSEChange(Sender: TObject);
begin FXPanel.CellSize := CSizeSE.Value; end;

procedure TXwOptPanelF.FontNaeCBChange(Sender: TObject);
begin FXPanel.Font.Name := FontNameCB.Text; end;

procedure TXwOptPanelF.FontSizeSEChange(Sender: TObject);
begin FXPanel.Font.Size := FontSizeSE.Value; end;

procedure TXwOptPanelF.FontBoldCBClick(Sender: TObject);
begin
  if FontBoldCB.Checked then FXPanel.Font.Style := FXPanel.Font.Style + [fsBold]
  else                       FXPanel.Font.Style := FXPanel.Font.Style - [fsBold];
end;
procedure TXwOptPanelF.EdFontNmeCBChange(Sender: TObject);
begin FWEdit.Font.Name := EdFontNameCB.Text; end;

procedure TXwOptPanelF.EdFontSizeSEChange(Sender: TObject);
begin FWEdit.Font.Size := EdFontSizeSE.Value; end;

procedure TXwOptPanelF.EdFontBoldCBClick(Sender: TObject);
begin
  if EdFontBoldCB.Checked then FWEdit.Font.Style := FWEdit.Font.Style + [fsBold]
  else                         FWEdit.Font.Style := FWEdit.Font.Style - [fsBold];
end;

procedure TXwOptPanelF.DeFontNameCBChange(Sender: TObject);
begin FWDesc.Font.Name := DeFontNameCB.Text; end;

procedure TXwOptPanelF.DeFontSizeSEChange(Sender: TObject);
begin FWDesc.Font.Size := DeFontSizeSE.Value; end;

procedure TXwOptPanelF.DeFontBoldCBClick(Sender: TObject);
begin
  if DeFontBoldCB.Checked then FWDesc.Font.Style := FWDesc.Font.Style + [fsBold]
  else                         FWDesc.Font.Style := FWDesc.Font.Style - [fsBold];
end;

end.
