unit xw2htmlU;

interface

uses
  XWType, XWObj, XWCont, HtmlExport, XwAboutWebU, 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TXw2htmlF = class(TForm)
    OpenD: TOpenDialog;
    Label1: TLabel;
    Label2: TLabel;
    OpenBB: TBitBtn;
    ConvertBB: TBitBtn;
    ExitBB: TBitBtn;
    SouL: TLabel;
    DestL: TLabel;
    AboutSB: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenBBClick(Sender: TObject);
    procedure ConvertBBClick(Sender: TObject);
    procedure AboutSBClick(Sender: TObject);
  private
    XWCollection : TXWordCollection;
    XWFileName, HtmlFileName : string;
    FXWLoaded : boolean;

    procedure LoadPattern( FName : string);
    function LoadFromEncriptStream( Stream : TStream) : boolean;
    procedure SetXWLoaded( Value : boolean);
    property XWLoaded : boolean read FXWLoaded write SetXWLoaded;
  public
    { Public declarations }
  end;

var
  Xw2htmlF: TXw2htmlF;

implementation
{$R *.DFM}

procedure TXw2htmlF.FormCreate(Sender: TObject);
begin
  XWLoaded := false;
  XWCollection := TXWordCollection.Create;
end;

procedure TXw2htmlF.FormDestroy(Sender: TObject);
begin
  XWCollection.Free;
end;

procedure TXw2htmlF.LoadPattern( FName : string);
var
  FN, FExt : string;
  Loaded : boolean;

  function LoadTextPattern( FN : string) : boolean;
  begin
    XWCollection.LoadFromTextFile( FN);
    Result := true;
  end;

  function LoadCompressPattern( FN : string) : boolean;
  var
    Stre : TFileStream;
  begin
    Stre := TFileStream.Create( FN, fmOpenRead);
    Result := LoadFromEncriptStream( Stre);
    Stre.Free;
  end;

  function LoadDesktop( FN : string) : boolean;
  var
    Stre : TFileStream;
  begin
    Stre := TFileStream.Create( FN, fmOpenRead);
    Result := LoadFromEncriptStream( Stre);
    Stre.Free;
  end;

begin
  FN := '';
  Loaded := false;
  if FName <> '' then FN := FName
  else begin
    OpenD.Title := 'Open XWord file';
    if OpenD.Execute then FN := OpenD.FileName;
    end;
  if FN <> '' then begin
    FExt := AnsiLowerCase( ExtractFileExt( FN));
    if FExt = AnsiLowerCase( extXWPattern) then
      Loaded := LoadTextPattern( FN) else
    if FExt = AnsiLowerCase( extComprXWPattern) then
      Loaded := LoadCompressPattern( FN) else
    if FExt = AnsiLowerCase( extXWDesktop) then
      Loaded := LoadDesktop( FN);
    if Loaded then begin
      XWFileName := FN;
      HtmlFileName := FN;
      System.Delete( HtmlFileName,
                     Pos( '.', HtmlFileName),
                     length( HtmlFileName) - Pos( '.', HtmlFileName) + 1);
      HtmlFileName := HtmlFileName + '.html';
      XWLoaded := Loaded;
      end;
    end;
end;

function TXw2htmlF.LoadFromEncriptStream( Stream : TStream) : boolean;
var
  EStre : TWxEncriptionStream;
  LoadCou : integer;
begin
  EStre := TWxEncriptionStream.Create;
  EStre.CopyFrom( Stream, Stream.Size);

  EStre.Decript;
  EStre.Position := 0;

  LoadCou := 0;
  try
    while ( EStre.Position <= EStre.Size - 1) AND ( LoadCou < 10) do begin
      XWCollection.LoadFromStream( EStre);
      inc( LoadCou);
      end;
    Result := LoadCou < 10;
  except Result := false; end;

  EStre.Free;
end;

procedure TXw2htmlF.SetXWLoaded( Value : boolean);
begin
  FXWLoaded := Value;
  ConvertBB.Enabled := FXWLoaded;
  if FXWLoaded then begin
    SouL.Caption := ExtractFileName( XWFileName);
    DestL.Caption := ExtractFileName( HtmlFileName);
    end
  else begin
    SouL.Caption := '';
    DestL.Caption := '';
    end;
end;

procedure TXw2htmlF.OpenBBClick(Sender: TObject);
begin
  LoadPattern( '');
end;

procedure TXw2htmlF.ConvertBBClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try
    ExportHTML( XWCollection, HtmlFileName);
  finally
    Screen.Cursor := crDefault;
    end;
end;


procedure TXw2htmlF.AboutSBClick(Sender: TObject);
begin
  XwAboutWebF.ShowModal;
end;

end.
